import java.io.*;
import ssdbms.ssd.*;
import ssdbms.manager.primitives.*;
import storage.primitiveStorage.*;
import storage.intermediateStorage.*;
import storage.advancedStorage.*;
import storage.*;
import DbStorage.*;
import DbStorage.driver.*;
import DbStorage.primitives.*;
import DbStorage.manager.*;
import concurrency.*;
import kernelInterface.*;
import java.util.*;

public class Pru02
{
    DbInterface dbi;
    DbManager dbm;

    public Pru02()
	throws Exception
    {
	int pageSize=4096;

	DbStorageManager dbsm=new DbStorageManager(new PrimitiveStorageManager(pageSize,4*1024*1024));
	dbsm.createDefaultSettings(new File("."));
	DbUnitAddress header=new DbUnitAddress(0,0);
	DictionaryHeaderDriver.createDictionaryHeader(dbsm,0,header);
	DictionaryManager.formatHeader(dbsm,0,header);
	dbm=new DbManager(dbsm,header);
	ConcurrencyManager cm=new ConcurrencyManager(0);
	dbi=new DbInterface(dbm,cm);
    }

    public class Proccess extends Thread
    {
	public void run()
	{
	    try {
		ID id00=dbi.createNonPrimitive();
		dbi.addSSDTable(new Label("examples"),id00);
		
		Label l=new Label("example");
		for (int i=0; i<2000; i++)
		    {
			dbi.add(id00,l,dbi.createInteger(new IntegerValue(i)));
			//dbi.createInteger(new IntegerValue(i));
			if (i%100==99)
			    System.out.print(".");
		    }
		System.out.println("+");

		//SetOfLabeledSSD s=dbi.getAllContent(id00);
		SetOfLabeledSSD s=dbi.getContentWithID(id00,id00);
		while (s.hasNext())
		    System.out.print(s.next().toString()+" ");
		System.out.println("+");    
		
		dbi.commit();
		dbm.getAdvancedStorageManager().synchronize();
	    } catch (Exception e) {
		System.err.println("ERROR: "+e.getMessage());
		e.printStackTrace();
	    }
	}
	
    }

    public void go()
	throws Exception
    {
	(new Proccess()).start();
    }

    static public void main(String[] argv)
    {
	try {
	    (new Pru02()).go();
	} catch (Exception e) {
	    System.err.println("ERROR: "+e.getMessage());
	    e.printStackTrace();
	}
    }
}
