import java.io.*;
import ssdbms.ssd.*;
import ssdbms.manager.primitives.*;
import storage.primitiveStorage.*;
import storage.intermediateStorage.*;
import storage.advancedStorage.*;
import storage.*;
import DbStorage.*;
import DbStorage.driver.*;
import DbStorage.primitives.*;
import DbStorage.manager.*;
import concurrency.*;
import kernelInterface.*;
import java.util.*;

public class Pru04
{

   
    static public void main(String[] argv)
    {
	try {
	    int pageSize=4096;

	    DbStorageManager dbsm=new DbStorageManager(new PrimitiveStorageManager(pageSize,4*1024*1024));
	    dbsm.createDefaultSettings(new File("."));
	    DbUnitAddress header=new DbUnitAddress(0,0);
	    DictionaryHeaderDriver.createDictionaryHeader(dbsm,0,header);
	    DictionaryManager.formatHeader(dbsm,0,header);
	    DbManager dbm=new DbManager(dbsm,header);
	    
	    long trans=0;

	    ID id00=dbm.createNonPrimitive(trans);
	    dbm.addSSDTable(new Label("examples"),(PhysicalID)id00,trans);
	    
	    Label l=new Label("example");
	    long curr=System.currentTimeMillis();
	    System.out.print("+");
	    for (int i=0; i<1000000; i++)
		{
		    //dbi.add(id00,l,dbi.createInteger(new IntegerValue(i)));
		    dbm.createInteger(new IntegerValue(i),trans);
		    if (i%10000==9999)
			System.out.print(".");
		}
	    System.out.println("+ "+(System.currentTimeMillis()-curr));
	    
	    //SetOfLabeledSSD s=dbi.getAllContent(id00);
	    dbm.getAdvancedStorageManager().synchronize();
	} catch (Exception e) {
	    System.err.println("ERROR: "+e.getMessage());
	    e.printStackTrace();
	}
    }
}
