import java.io.*;
import ssdbms.ssd.*;
import ssdbms.manager.primitives.*;
import storage.primitiveStorage.*;
import storage.intermediateStorage.*;
import storage.advancedStorage.*;
import storage.*;
import DbStorage.*;
import DbStorage.driver.*;
import DbStorage.primitives.*;
import DbStorage.manager.*;
import concurrency.*;
import kernelInterface.*;
import java.util.*;

public class Pru08
{
    DbInterface dbi;

    public Pru08()
	throws Exception
    {
	dbi=DbTools.loadDb(new File("data"));
    }

    public class Proccess extends Thread
    {
	public void showID(ID id)
	    throws Exception
	{
	    System.out.print(id.toString()+" ");
	    int type=dbi.getType(id);
	    
	    if (type==SSDValue.INTEGER)
		System.out.print(((IntegerValue)(dbi.getContent(id))).getValue());
	    else if (type==SSDValue.REAL)
		System.out.print(((RealValue)(dbi.getContent(id))).getValue());
	    else if (type==SSDValue.STRING)
		System.out.print("\""+((StringValue)(dbi.getContent(id))).getValue()+"\"");
	    else if (type==SSDValue.BYTE_SEQUENCE)
		{
		    byte[] b=((ByteSequenceValue)(dbi.getContent(id))).getValue();
		    System.out.print("[ ");
		    for (int i=0; i<b.length; i++)
			System.out.print(Integer.toHexString(0xFF&b[i])+" ");
		    System.out.print("]");
		}
	    else if (type==SSDValue.BLOB)
		System.out.print("BLOB("+((BLOBManager)(dbi.getContent(id))).length()+")");
	    else if (type==SSDValue.CLOB)
		System.out.print("CLOB("+((CLOBManager)(dbi.getContent(id))).length()+")");
	    else if (type==SSDValue.NON_PRIMITIVE)
		{
		    System.out.print("{ ");
		    SetOfLabeledSSD s=((SetOfLabeledSSD)(dbi.getContent(id)));
		    while (s.hasNext())
			{
			    LabeledSSD lssd=s.next();
			    System.out.print(lssd.getLabel().toString()+":");
			    showID(lssd.getID());
			    if (s.hasNext())
				System.out.print(",");
			    System.out.print(" ");
			}
		    System.out.print("}");
		}
	    else
		System.out.println("UNKNOWN_CONTENT");
	}

	public void showSSDTable(Label name)
	    throws Exception
	{
	    System.out.print(name.toString()+":");
	    showID(dbi.getRoot(name));
	    System.out.println("");
	}
	
    }

    public class Proccess1 extends Proccess
    {
	public void run()
	{
	    try {
		System.out.println("BEGINNING TRANSACTION");
		System.out.print("TABLE ");showSSDTable(new Label("t1"));
		System.out.println("ENDING TRANSACTION");
		dbi.commit();
	    } catch (Exception e) {
		System.err.println("ERROR: "+e.getMessage());
		e.printStackTrace();
	    }
	}
	
    }

    public void go()
	throws Exception
    {
	(new Proccess1()).start();
    }

    static public void main(String[] argv)
    {
	try {
	    (new Pru08()).go();
	} catch (Exception e) {
	    System.err.println("ERROR: "+e.getMessage());
	    e.printStackTrace();
	}
    }
}
