package concurrency;

import DbStorage.PhysicalID;

/**
 * Represents the content of a datum.
 */
public class DatumContent extends LockableObject
{
    PhysicalID id;

    /**
     * Constructs a datum content from a specified identifier.
     */
    public DatumContent(PhysicalID id)
    {
	this.id=new PhysicalID();
	this.id.copyFrom(id);
    }

    /**
     * Returns the identifier of the owner datum of the content.
     */
    public PhysicalID getID()
    {
	return id;
    }

    public String toString()
    {
	return "CONTENT("+id.getSpaceNumber()+"-"+id.getUnitNumber()+")";
    }
}
