package concurrency;

import DbStorage.PhysicalID;

/**
 * Represents the view of a datum.
 */
public class DatumView extends LockableObject
{
    PhysicalID id;

    /**
     * Constructs a datum view from a specified identifier.
     */
    public DatumView(PhysicalID id)
    {
	this.id=new PhysicalID();
	this.id.copyFrom(id);
    }

    /**
     * Returns the identifier of the owner datum of the view.
     */
    public PhysicalID getID()
    {
	return id;
    }

    public String toString()
    {
	return "VIEW("+id.getSpaceNumber()+"-"+id.getUnitNumber()+")";
    }
}
