package concurrency;

/**
 * This class represents a transaction, encloses a number of transaction.
 */
public class Transaction
{
    private long transactionNumber;
    private long creationTime;

    
    /**
     * Constructs a transaction with a specified number.
     */
    public Transaction(long number)
    {
	transactionNumber=number;
	creationTime=System.currentTimeMillis();
    }
    
    /**
     * Returns the transaction number.
     */
    public long getTransactionNumber()
    {
	return transactionNumber;
    }

    /**
     * Returns the creation time of the transaction.
     */
    public long getCreationTime()
    {
	return creationTime;
    }

    /**
     * Compare if two transactions has the same number.
     */
    public boolean equals(Transaction trans) 
    {
	return this.transactionNumber==trans.transactionNumber;
    }

    public boolean equals(Object obj) 
    {
	return this.transactionNumber==((Transaction)obj).transactionNumber;
    }

    /**
     * Compares two transactions using their numbers.
     */
    public int compare(Transaction t)
    {
	if (transactionNumber>t.transactionNumber)
	    return 1;
	else if (transactionNumber<t.transactionNumber)
	    return -1;
	else
	    return 0;
    }

    public int compare(Object obj)
    {
	return compare((Transaction)obj);
    }

    /**
     * A comparator to order transactions.
     */
    static public class Comparator implements java.util.Comparator
    {
	public int compare(Object o1, Object o2)
	{
	    return ((Transaction)o1).compare((Transaction)o2);
	}
	
	public boolean equals(Object obj)         
	{
	    return obj instanceof Comparator;
	}
    }

    /**
     * The transactions' comparator.
     */
    static public Comparator comparator=new Comparator();

    public String toString()
    {
	return ""+transactionNumber;
    }
}
