package ssdbms.manager.primitives;

import ssdbms.ssd.*;

/**
 * A <code>SetOfID</code> is used to storage identifiers of semistructured data
 * and recover them in sequential order.
 *
 * @see ID
 * @author Egar Arturo Garca Crdenas
 */
public interface SetOfID
{
    /**
     * Returns <code>true</code> if the sequence has more identifiers. 
     * It means, the sequence has not been completely covered.
     *
     * @return <code>true</code> if there is more identifiers, <code>false</code> otherwise. 
     */ 
    public boolean hasNext() throws BadFunctionException, FatalErrorException;

    /**
     * Returns the next identifier in the sequence and shift one element.
     *
     * @return The next identifier in the sequence, the first time that this method
     * is called return the firs element in the sequence,  
     * <code>null</code> if there is not more identifiers.
     */ 
    public ID next() throws BadFunctionException, FatalErrorException;
}
