package ssdbms.ssd;

/**
 * This class represents a sequence ob bytes. 
 * It uses a byte array to storage the content of the datum.
 *
 * @see SimpleValue
 * @see PrimitiveValue
 * @author Egar Arturo Garca Crdenas.
 */
public final class ByteSequenceValue implements SimpleValue
{
    private byte[] data;

    /**
     * Constructs a byte sequence represents the given byte array. 
     * @exception BadSSDValueException If <code>bytes</code> is <code>null</code>.
     */
    public ByteSequenceValue(byte[] bytes) throws BadSSDValueException
    {
	if (bytes!=null)
	    data=bytes;
	else
	    throw new BadSSDValueException("ByteSequence value can't be constructed");
    }

    /*
     * Returns the <code>byte</code> array representation of this value.
     *
     * @return A <code>byte</code> array that represents the value stored.
     */
    public byte[] getValue()
    {
	return data;
    }
}
