package ssdbms.ssd;

/**
 * This class represents a integer primitive value. 
 * It wraps a java long variable to storage the content of the datum.
 *
 * @see SimpleValue
 * @see PrimitiveValue
 * @author Egar Arturo Garca Crdenas.
 */
public final class IntegerValue implements SimpleValue
{
    static public final int SIZE=8;
    
    private long data;

    /**
     * Constructs a integer primitive value from a java long value. 
     */
    public IntegerValue(long value)
    {
	data=value;
    }

    /**
     * Returns the <code>long</code> representation of the integer value.
     *
     * @return A <code>long</code> that represents the value stored.
     */
    public long getValue()
    {
	return data;
    }
}

