package ssdbms.ssd;

/**
 * A <code>LOBValue</code> is an special case of <code>PrimitiveValue</code>,
 * designed to manage very large objects that can not be stored or easily manipulated in memory.
 * Very database manager sstems use LOB (Large Object) values to storage large objects like: 
 * Images, music, large texts, etc. In semistructured databases is the same idea.
 *
 * @see BLOBValue
 * @see CLOBValue
 * @see PrimitiveValue
 * @author Egar Arturo Garca Crdenas
 */
public interface LOBValue extends PrimitiveValue
{
}
