package ssdbms.ssd;

/**
 * This interface represents a primitive value of a semistructured datum.
 * Primitive value subdivides in two kinds: Simple values and LOB (Large Object) values,
 * naively simple values are enough small to be managed in memory, 
 * LOB values are too large to be easily managed in memory.
 *
 * @see SimpleValue
 * @see LOBValue
 * @see SSDValue
 * @author Egar Arturo Garca Crdenas
 */
public interface PrimitiveValue extends SSDValue
{
}


