package ssdbms.ssd;

/**
 * This class represents a real primitive value. 
 * It wraps a java double variable to storage the content of the datum.
 *
 * @see SimpleValue
 * @see PrimitiveValue
 * @author Egar Arturo Garca Crdenas.
 */

public final class RealValue implements SimpleValue
{
    private double data;

    /**
     * Constructs a real primitive value from a java double value. 
     */
    public RealValue(double value)
    {
	data=value;
    }
    
    /**
     * Returns the <code>double</code> representation of the real value.
     *
     * @return A <code>double</code> that represents the value stored.
     */
    public double getValue()
    {
	return data;
    }
}






