package ssdbms.ssd;

/**
 * A <code>SimpleValue</code> is an special case of <code>PrimitiveValue</code>,
 * designed for database managers, naively a simple value is a primitive value
 * that can be stored and easily manipulated in memory.
 * Simple primitive values provides in this API are integers, reals, strings and byte sequences,
 * those are mapped to an equivalen Java data type.
 *
 * @see IntegerValue
 * @see RealValue
 * @see StringValue
 * @see ByteSequenceValue
 * @see PrimitiveValue
 * @author Egar Arturo Garca Crdenas
 */
public interface SimpleValue extends PrimitiveValue
{
}

