package ssdbms.ssd;

/**
 * This class represents a string primitive value. 
 * It wraps a java string variable to storage the content of the datum.
 *
 * @see SimpleValue
 * @see PrimitiveValue
 * @author Egar Arturo Garca Crdenas.
 */
public final class StringValue implements SimpleValue
{
    private String data;

    /**
     * Constructs a string primitive value represents the given java string. 
     * @exception BadSSDValueException If <code>value</code> is <code>null</code>. 
     */
    public StringValue(String value) throws BadSSDValueException
    {
	if (value!=null)
	    data=value;
	else
	    throw new BadSSDValueException("String value can't be constructed");
    }
    
    /**
     * Returns the <code>String</code> representation of this value.
     *
     * @return A <code>String</code> that represents the value stored.
     */
    public String getValue()
    {
	return data;
    }
}
