package storage;

/**
 * This class is used to reference a unit inside a segment.
 * A unit address is formed by a space number and a unit number.  
 */
public class UnitAddress
{
    private int spaceNumber;
    private long unitNumber;
    
    /**
     * Constructs a new unit address with space and unit numbers in -1.
     */
    public UnitAddress()
    {
	this.spaceNumber=-1;
	this.unitNumber=-1;
    }

    /**
     * Constructs a new unit address with specified space and unit number.
     */
    public UnitAddress(int spaceNumber, long unitNumber)
    {
	this.spaceNumber=spaceNumber;
	this.unitNumber=unitNumber;
    }
    
    /**
     * Returns the space number.
     */
    public int getSpaceNumber()
    {
	return spaceNumber;
    }
    
    /**
     * Returns the unit number.
     */
    public long getUnitNumber()
    {
	return unitNumber;
    }

    /**
     * Sets the space and unit numbers of the address.
     */
    public void set(int spaceNumber, long unitNumber)
    {
	this.spaceNumber=spaceNumber;
	this.unitNumber=unitNumber;
    }

    /**
     * Checks if two unit address have the same values.
     */
    public boolean equals(UnitAddress addr)
    {
	return this.getSpaceNumber()==addr.getSpaceNumber() && this.getUnitNumber()==addr.getUnitNumber();
    }
}
